#!/usr/bin/perl

chdir("/var/log/bandwidth") || die "can't chdir";          

if(-e "/var/log/bandwidth/version") {
	print "1.0 upgrade already done\n";
	exit;
}

$level = '';
$DIRS{"."} = 0;

$count = 0;
while (1) {
   foreach $ex (keys %DIRS) {
      if ($DIRS{$ex} == 0) {
         $count--;
         @DS = getdirls($ex);
         foreach $item (@DS) {
            if (-d $ex . "/" . $item && ! -l $ex . "/" . $item) {
               if ($item ne "..") {
                  if ($item ne ".") {
#print "-";  
                     if ($item !~ /^_vti_/) { #evil frontpage
                        $DIRS{$ex . "/" . $item} = 0;
                        $count++;
                     }
                  }
               }
            } else {    
               if (-f $ex . "/" . $item) {
#print "+";
                        push (@FILES,$ex . "/" . $item);
               } else {
                  print "S";
               }
            }
         }
         $DIRS{$ex} = 1;
      }

   }
   if ($count < 0) { last; }
}
delete @DIRS{keys %DIRS};   

                        
while($file = shift(@FILES)) {
	$file =~ s/^.\///g;
	next if ($file !~ /\//);
	print "Converting $file\n";
	open(TF,"/var/log/bandwidth/${file}");
	open(TFT,">/var/log/bandwidth/${file}.tmp");
	while(<TF>) {
		s/\n//g;
		($ip,$bytes) = split(/=/, $_);
		if ($ip =~ /^\d*\.\d*\.\d*\.\d*$/) {
			$ip = "${ip}-all-out";
		}
		if ($ip eq "all") {
			$ip = 'all-all';
		}
		print TFT "$ip=$bytes\n";
	}
	close(TFT);
	close(TF);
	unlink("/var/log/bandwidth/${file}");
	link("/var/log/bandwidth/${file}.tmp","/var/log/bandwidth/${file}");
	unlink("/var/log/bandwidth/${file}.tmp");
}

open(UPBW,">/var/log/bandwidth/version");
print UPBW "1.0";
close(UPBW);


sub getdirls {
   my($dirls) = $_[0];
   my(@DIR);
   opendir(SDIR,$dirls);
   @DIR=readdir(SDIR);
   closedir(SDIR);
   return(@DIR);
}


